"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const opentracing_1 = require("opentracing");
const util_1 = require("./util");
const Fork_1 = require("./Fork");
const Promise = require("bluebird");
class ForkHttp extends Fork_1.default {
    constructor() {
        super(...arguments);
        this.services = [];
    }
    forksConfig(conf) {
        console.log(conf);
        this.services = conf;
    }
    message(data, Method, params) {
        return new Promise((rr, ff) => {
            // rr(this.formatResponse(data, null, 0));
            const paraInject = [];
            // Ejecutar todas las peticions a los servicios REST.
            Promise.each(this.services, (service) => {
                //
            })
                .then((result) => {
                try {
                    params.forEach((value) => {
                        if (value === 'uuid') {
                            paraInject.push(data.metadata.uuid);
                        }
                        else if (value === 'filters') {
                            paraInject.push(this.transformFilters(data.metadata.filters));
                        }
                        else if (value === 'authorizacion') {
                            paraInject.push(data.headers.Authorizacion);
                        }
                        else if (value === 'data') {
                            paraInject.push(data.metadata.data_inicial);
                        }
                        else if (value === 'response') {
                            if (data.response &&
                                data.response.data &&
                                data.response.data.response) {
                                paraInject.push(data.response.data.response);
                            }
                            else {
                                paraInject.push(data.data);
                            }
                        }
                        else if (value === 'parentSpan') {
                            paraInject.push(this.span);
                        }
                    });
                    const resp = Method.apply({}, paraInject);
                    // Validar si la respuesta es una promesa y esperar a resolverla
                    if (util_1.default.isPromise(resp)) {
                        // Esperar que finalice
                        resp.then((response) => {
                            // Regresar el contenido
                            rr(this.formatResponse(data, response, 0));
                        }).catch((error) => {
                            this.span.setTag(opentracing_1.Tags.ERROR, true);
                            this.span.log({
                                'error.message': error.message,
                                'error.object': error,
                                'error.stack': error.stack,
                                // tslint:disable-next-line: object-literal-key-quotes
                                event: 'error',
                            });
                            // Indicar que fue error
                            ff(this.formatResponse(data, null, error.code));
                        });
                    }
                    else {
                        // Regresar la respuesta
                        rr(this.formatResponse(data, resp, 0));
                    }
                }
                catch (error) {
                    this.span.setTag(opentracing_1.Tags.ERROR, true);
                    this.span.log({
                        'error.message': error.message,
                        'error.object': error,
                        'error.stack': error.stack,
                        // tslint:disable-next-line: object-literal-key-quotes
                        event: 'error',
                    });
                    // Regresar el error
                    ff(this.formatResponse(data, null, error.code));
                }
            })
                .catch((rejection) => {
                //
            });
        });
    }
}
exports.default = ForkHttp;
